<?php
/**
 * ElementorSheets Dependency Checker
 *
 */
class ElementorSheets_Dependencies {
	private static $elementorsheets_active_plugins;
	static function elementorsheets_dependencies_action_init() {
		self::$elementorsheets_active_plugins = (array) get_option( 'active_plugins', array() );
	}
	/**
	 * Check Elementor Pro exist
	 * @return Boolean
	 */
	public static function elementor_pro_active_check() {
		if (!self::$elementorsheets_active_plugins)
			self::elementorsheets_dependencies_action_init();
		return in_array('elementor-pro/elementor-pro.php', self::$elementorsheets_active_plugins) || array_key_exists('elementor-pro/elementor-pro.php', self::$elementorsheets_active_plugins);
	}
	/**
	 * Check if Elementor Pro active
	 * @return Boolean
	 */
	public static function is_elementor_pro_active() {
		return self::elementor_pro_active_check();
	}
}
