(function($) {
	"use strict";
	$(document).ready(function(){
		$("#authlink").on('click',function(e){ 
			$( '#authbtn' ).hide();
			document.getElementById("authtext").style.display="inline-block";				
		});
		$("#revoke").on('click',function(e){ 
			document.getElementById("authtext").style.display="none";
			document.getElementById("client_token").style.display="none";				
		});
		$('#licence_submit').on('click', function(e) {
			e.preventDefault();
			$( '.elementorsheets-license-result' ).html( '' );
			$( '#licence_submit' ).hide();
			$( '#licenceloader' ).show();
			$( '#licencetext' ).show();
			elementorsheets_license_check( 'activate' ); 
		});	
	});
	$(document).ready(function(){
		var activetab = getParameterByName('tab');
		if( activetab != null){
			elementorsheetstab(event, activetab);
			var classnm = "button."+activetab;	
			$(classnm).addClass('active');
		}else{
			var classnm = "button.googleapi-settings";	
			$(classnm).addClass('active');
		}
	});
})(jQuery);
function elementorsheetstab(evt, tabName) {
  var i, tabcontent, tablinks;
  tabcontent = document.getElementsByClassName("tabcontent");
  for (i = 0; i < tabcontent.length; i++) {
	tabcontent[i].style.display = "none";
  }
  tablinks = document.getElementsByClassName("tablinks");
  for (i = 0; i < tablinks.length; i++) {
	tablinks[i].className = tablinks[i].className.replace(" active", "");
  }
  document.getElementById(tabName).style.display = "block";
  evt.currentTarget.className += " active";
}

function getParameterByName(name, url) {
	if (!url) url = window.location.href;
	name = name.replace(/[\[\]]/g, '\\$&');
	var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
		results = regex.exec(url);
	if (!results) return null;
	if (!results[2]) return '';
	return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

function elementorsheets_license_check( action ) {
	
		if( jQuery( '#ws_envato' ).val() == '' ){
			jQuery( '.elementorsheets-license-result' ).html( '<div class="error"><p>Please enter Envato API Token</p></div>' );
			jQuery( '#licenceloader' ).hide();
			jQuery( '#licencetext' ).hide();
			jQuery( '#licence_submit' ).show();
			return false;		
		}
		
		var data = {
			action: 'elementorsheets_' + action + '_license',
			api_key: jQuery( '#ws_envato' ).val(),
			wpnonce	: jQuery( '#_wpnonce' ).val()
		};
		jQuery.post( admin_ajax_object.ajaxurl, data, function ( response ) {
			var html;
			if ( ! response || response == - 1 ) {
				html = 'Please enter valid Envato API Token';
			} else if ( response && response.message && response.result
				&& (response.result == '-3' || response.result == '-2'
				|| response.result == 'wp_error' || response.result == 'server_error') ) {
				html = response.message;
			} else if ( response && response.message && response.result && (response.result == '4') ) {
				html = response.message;
			} else {
				html = '';
			}
			jQuery( '.elementorsheets-license-result' ).html( html );
			jQuery( '#licenceloader' ).hide();
			jQuery( '#licencetext' ).hide();
			jQuery( '#licence_submit' ).show();
			}, 'json' )
			.always( function ( response ) {});
}
function elementorsheets_copy( id, targetid ) {
    var copyText = document.getElementById(id);
    var textArea = document.createElement("textarea");
	textArea.value = copyText.textContent;
	document.body.appendChild(textArea);
	textArea.select();
	document.execCommand("Copy");
	textArea.remove();
}