jQuery(document).ready(function(){
var headernamesglobal = [];
(function (e, ep, $) {
    var ElementorSheetsoptinIntegration = {
        onElementChange: function onElementChange(setting) {
            var self = this;
            switch (setting) {
			    case 'generate_mapping':
                    self.updateFieldsMapping();
					break;
            }
        },
		onSectionActive: function onSectionActive(setting) {
			 var self = this;
			 this.updateFieldsMapping();
			 var newlist = '';
			 if( headernamesglobal.length > 0)
				 jQuery('#sortable').html('');
			 for (i = 0; i < headernamesglobal.length; ++i) {
				var labelid = headernamesglobal[i].replace(/ /g,"-").toLowerCase();
				var newlist = '<li class="ui-state-default ui-sortable-handle"><label for="'+labelid+'"><span class="ui-icon ui-icon-caret-2-n-s"></span><div id="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'-wrap" class="elementorsheets-panel-field custom-swap custom-sort-headers elementorsheets-panel-field-checkbox"><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'" class="inline hdrtext">'+headernamesglobal[i]+'</label><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'"><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'"><span class="ui-icon ui-icon-close" data-header-name='+headernamesglobal[i]+'></span></label><span class="checkbox-switch"></span></label></div></li>';		
				jQuery('#sortable').append(newlist); 
			 }
			$( "#sortable" ).sortable({
				 update: function(event, ui) {
					 headernamesglobal = [];
					 $('ul#sortable li .hdrtext').each(function(i)
					{
					   if( $(this).text() != '' ){
							headernamesglobal.push($.trim($(this).text()));
						}

					});
					self.onElementChange('generate_mapping');
				},	
			});
			$("#sortable").on('sortupdate',function() {
				self.onElementChange('generate_mapping');
			});
			
			$('body').on('click', '.elementorsheets-sheetsheaders .ui-icon-close' ,function(e) {
				
				var removeItem = $(this).attr('data-header-name');
				headernamesglobal = $.grep(headernamesglobal, function(value) {
					return value != removeItem;
			  	});
				
				$(this).closest('li').fadeOut( 1000, function() { $(this).closest('li').remove(); });
				setTimeout(function(){
					$('#sortable').trigger('sortupdate');
				},1100);
			});
			
			var availableFormField = $("#form_all_headers").html().split(",");
			availableFormField = $.grep(availableFormField, function(value) {
				if( jQuery.inArray(value, headernamesglobal ) == -1 ){
					return value;	
				}
			});
			$( 'input[data-setting=header_name]' ).autocomplete({
			  source: availableFormField
			});
        },
		 updateFieldsMapping: function updateFieldsMapping(model) {
			var self = this;
			self.getEditorControlView('elementorsheets_fields_map').$el.hide();
			var headernames = [];
			$('ul#sortable li .hdrtext').each(function(i)
			{
			   if( $(this).text() != '' ){
				   headernames.push($.trim($(this).text()));
				   if( jQuery.inArray($.trim($(this).text()), headernamesglobal ) == -1 ){
				   	headernamesglobal.push($.trim($(this).text()));
				   }
				}
			   		
			});
			var availableFormField = $("#form_all_headers").html().split(",");
			availableFormField = $.grep(availableFormField, function(value) {
				if( jQuery.inArray(value, headernamesglobal ) == -1 ){
					return value;	
				}
			});
			$( 'input[data-setting=header_name]' ).autocomplete({
			  source: availableFormField
			});
			var i;
			var remoteFields = [];
			for (i = 0; i < headernamesglobal.length; ++i) {
				var filedarray = {
					remote_label: headernamesglobal[i],
					remote_type: 'text',
					remote_id: headernamesglobal[i].toLowerCase(),
					remote_required: false
				};
				remoteFields.push(filedarray);
			}
			self.getEditorControlView('elementorsheets_fields_map').updateMap(remoteFields);
			self.getEditorControlView('elementorsheets_fields_map').$el.show();
	     },
    };
    ep.modules.forms.elementorsheets = Object.assign(ep.modules.forms.mailchimp, ElementorSheetsoptinIntegration);
    ep.modules.forms.elementorsheets.addSectionListener('section_elementorsheets', ElementorSheetsoptinIntegration.onSectionActive);
})(elementor, elementorPro, jQuery);
	elementor.channels.editor.on('namespace:editor:getheaders',function( view ) {
		
		var cst_val = jQuery('input[data-setting=header_name]').val();
		if( jQuery.inArray(cst_val, headernamesglobal ) != -1 ){
			alert('Please enter unique sheet header name');
			return false;	
		}
		var labelid = cst_val.replace(/ /g,"-").toLowerCase();
		var newlist = '<li class="ui-state-default ui-sortable-handle" style="display:none"><label for="'+labelid+'"><span class="ui-icon ui-icon-caret-2-n-s"></span><div id="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'-wrap" class="elementorsheets-panel-field custom-swap custom-sort-headers elementorsheets-panel-field-checkbox"><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'" class="inline hdrtext">'+cst_val+'</label><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'"><label for="elementorsheets-panel-field-elementorsheets-sheetheaders-'+labelid+'"><span class="ui-icon ui-icon-close" data-header-name='+cst_val+'></span></label><span class="checkbox-switch"></span></label></div></li>';		
		jQuery('#sortable').append(newlist);
	 	jQuery("#sortable li").each(function() {
		  if (jQuery(this).css('display') == 'none') {
			jQuery(this).fadeIn(2000);
		  }
	  	});		
		jQuery('input[data-setting=header_name]').val('');
		jQuery('#sortable').trigger('sortupdate');		
	});	
});